import { Module } from '@nestjs/common';
import { ExploitService } from './exploit.service';
import { ExploitDAO } from './exploit.dao';
import { ContractModule } from '../contract/contract.module';
import { SubscribeModule } from '../subscribe/subscribe.module';
import { BullModule } from '@nestjs/bull';
import { ExploitNotifyProcessor } from './queue/exploit-notify.processor';
import { EmailModule } from '../email/email.module';
import { UserModule } from '../user/user.module';
import { ExploitResolver } from './exploit.resolver';

@Module({
  imports: [
    BullModule.registerQueue({
      name: 'exploitNotify',
      limiter: { max: 1, duration: 60 * 1000 },
    }),
    ContractModule,
    SubscribeModule,
    EmailModule,
    UserModule,
  ],
  providers: [
    ExploitService,
    ExploitDAO,
    ExploitNotifyProcessor,
    ExploitResolver,
  ],
  exports: [ExploitService],
})
export class ExploitModule {}
